UG/NX 二次开发(C#) 获取组件表达式的2种方式

 UG 二开获取组件表达式是经常遇到的,这里列举2种获取表达式的方法:

1、有了组件文件路径,加载组件并获取表达式

2、有了组件的tag,获取组件表达式

        /// <summary>
        /// 获取组件的表达式的2种方式,修正表达式
        /// </summary>
        public static void GetExpressionDemo()
        {
           //1、有了组件了路径,加载组件并获取表达式
           string fullPartFile = AppDomain.CurrentDomain.BaseDirectory.ToString() + "Common\\3D\\block.prt";
           string fullPartFile1 = AppDomain.CurrentDomain.BaseDirectory.ToString() + "Common\\3D\\block1.prt";

           BasePart basePart1;
           Session theSession = Session.GetSession();
           PartLoadStatus partLoadStatus1;
           try
           {
               basePart1 = theSession.Parts.OpenBase(fullPartFile, out partLoadStatus1);
           }
           catch (Exception)
           {
               basePart1 = theSession.Parts.OpenBase(fullPartFile1, out partLoadStatus1);
           }
           ExpressionCollection expressionCollection = basePart1.Expressions;
           foreach (var ex in expressionCollection.ToArray())
           {
               string name = ex.Name;
           }

           //2、有了组件的tag,获取组件表达式
           NXOpen.UF.UFSession theUFSession;
           theUFSession = UFSession.GetUFSession();
           Tag tag = basePart1.Tag;
           int num;
           Tag[] tagArr;
           theUFSession.Modl.AskExpsOfPart(tag, out num,out tagArr);
           for (int i = 0; i < num; i++)
           {
               string expname = "";
               theUFSession.Modl.AskExpTagString(tagArr[i], out expname);
           }

           ExpressionModel expModel = new ExpressionModel();
           expModel.X = 100;
           expModel.Y = 50;
           expModel.Z = 50;
           //修正表达式 
           ComponentTool.UpdateExpression(expressionCollection, expModel);
        }

  • 3
    点赞
  • 6
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 0
    评论
UG/NX二次开发中,可以使用以下方法获取曲线的类型: 1. 获取曲线对象,例如线、圆、椭圆等。 2. 使用UG/Curve_Type.hxx头文件中的枚举类型,通过曲线对象的CurveType()方法获取曲线类型。 以下是一个示例代码,演示如何获取曲线类型: ``` #include <NXOpen/NXException.hxx> #include <NXOpen/Part.hxx> #include <NXOpen/PartCollection.hxx> #include <NXOpen/Features_Feature.hxx> #include <NXOpen/Features_FeatureCollection.hxx> #include <NXOpen/Features_FeatureType.hxx> #include <NXOpen/Features_BodyFeature.hxx> #include <NXOpen/Features_BodyFeatureCollection.hxx> #include <NXOpen/Curve.hxx> #include <NXOpen/Curve_Type.hxx> using namespace NXOpen; void getCurveType(Curve* curve) { if (curve == NULL) { return; } Curve::Type type = curve->CurveType(); switch (type) { case Curve::Type_Line: // do something for line break; case Curve::Type_Circle: // do something for circle break; case Curve::Type_Ellipse: // do something for ellipse break; // add more cases for other curve types default: // do something for unknown curve type break; } } int main(int argc, char* argv[]) { Part* part = NULL; PartCollection* partCollection = NULL; Features::Feature* feature = NULL; Features::FeatureCollection* featureCollection = NULL; Features::BodyFeature* bodyFeature = NULL; Features::BodyFeatureCollection* bodyFeatureCollection = NULL; Curve* curve = NULL; try { partCollection = NXOpen::Session::GetSession()->Parts(); part = partCollection->ActivePart(); featureCollection = part->Features(); feature = featureCollection->FindObject("feature_name", Features::FeatureType_Body); bodyFeatureCollection = feature->BodyFeatures(); bodyFeature = bodyFeatureCollection->FindObject("body_feature_name"); curve = dynamic_cast<Curve*>(bodyFeature->GetGeometryObject()); getCurveType(curve); } catch (NXException& ex) { // handle exception } return 0; } ```

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

MarcoPro

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值